<template>
	<v-row justify="center">
		<v-card min-width="1000">
			<v-card-title>
				Usuarios
				<v-spacer></v-spacer>
				<v-text-field v-model="filterName" prepend-icon="fas fa-search" label="Ingrese un nombre" />
			</v-card-title>
			<v-data-table
				:headers="headers"
				:items="items"
				:loading="loading"
				:search="filterName"
				:footer-props="{itemsPerPageText: 'Estudiantes por página'}"
				no-results-text="Usuario no encontrado"
				no-data-text="No hay solicitudes pendientes"
				loading-text="Esperando selección de beca"
			>
				<template v-slot:body="{ items }">
					<tbody>
						<tr v-for="item in items" :key="item.id" :style="[(item.status === 'Aprobada') ? accept : '', (item.status === 'Rechazada') ? reject : '']">
							<td>{{item.id}}</td>
							<td>{{item.name}}</td>
							<td>{{item.curp}}</td>
							<td>{{item.serial}}</td>
							<td>{{item.promedio}}</td>
							<td>{{item.type}}</td>
							<td>
								<v-tooltip bottom>
									<template v-slot:activator="{ on }">
										<v-btn
											text
											icon
											color="orange"
											v-on="on"
											:to="{
												name: 'InfoStudent',
												params: { student: item.curp }
											}"
										>
											<v-icon>fas fa-info</v-icon>
										</v-btn>
									</template>
									<span>Ver información</span>
								</v-tooltip>
								<v-tooltip bottom>
									<template v-slot:activator="{ on }">
										<v-btn
											text
											icon
											color="blue"
											v-on="on"
											:to="{
												name: 'DocumentsStudent',
												params: {
													student: item.curp,
													typeScholarshipAdmin: routeName
												}
											}"
										>
											<v-icon>fas fa-file-alt</v-icon>
										</v-btn>
									</template>
									<span>Ver documentos</span>
								</v-tooltip>
								<v-tooltip bottom>
									<template v-slot:activator="{ on }">
										<v-btn
											text
											icon
											color="#F8BBD0"
											v-on="on"
											@click="downloadFiles(item)"
										>
											<v-icon>fas fa-download</v-icon>
										</v-btn>
									</template>
									<span>Descargar documentos</span>
								</v-tooltip>
								<v-tooltip bottom>
									<template v-slot:activator="{ on }">
										<v-btn :disabled="!item.allDocumentsApproved || item.status === 'Aprobada'" 
											   text 
											   icon 
											   color="#72a051" 
											   v-on="on" 
											   @click="acceptScholarship(item)">
											<v-icon>fas fa-thumbs-up</v-icon>
										</v-btn>
									</template>
									<span>Aprobar solicitud</span>
								</v-tooltip>
								<v-tooltip bottom>
									<template v-slot:activator="{ on }">
										<v-btn :disabled="!item.allDocumentsApproved || item.status === 'Rechazada'" 
										       text 
											   icon 
											   color="#c51f2f" 
											   v-on="on" 
											   @click="rejectScholarship(item)">
											<v-icon>fas fa-thumbs-down</v-icon>
										</v-btn>
									</template>
									<span>Rechazar solicitud</span>
								</v-tooltip>
							</td>
						</tr>
					</tbody>
				</template>
			</v-data-table>
		</v-card>
	</v-row>
</template>

<script>
import gql from "graphql-tag";
import EventBus from "../../bus";
import { mapState } from "vuex";
import router from "../../router";
import axios from "axios";

export default {
	name: "UsersTable",
	data: () => ({
		// estilos para solicitudes aprobadas
		accept:{
			color: "white",
			backgroundColor: "#72a051"
		},
		// estilos para solicitudes rechazadas
		reject:{
			color: "white",
			backgroundColor: "#c51f2f"
		},
		filterName: "",
		routeName: "",
		loading: true,
		type: "",
		allDocumentsApproved: null,
		headers: [
			{ text: "Id", value: "id", filterable: false },
			{ text: "Nombre", value: "name", align:"center" },
			{ text: "CURP", value: "curp", filterable: false, align:"center" },
			{
				text: "Folio",
				value: "serial",
				filterable: false,
				align:"center"
			},
			{
				text: "Promedio",
				value: "promedio",
				filterable: false,
				align:"center"
			},
			,
			{
				text: "Tipo",
				value: "type",
				filterable: false,
				align:"center"
			},
			{ text: "Acciones", value: "action", align: "center" }
		],
		items: []
	}),
	computed: {
		...mapState(["userData"])
	},
	methods: {
		// obtiene las solicitudes de becas
		async getRequests(val) {
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query($scholarship: String!) {
							getScholarshipsRequestActualPeriod(
								scholarship: $scholarship
							) {
								name
								curp
								serial
								promedio
								type
								status
								allDocumentsApproved
							}
						}
					`,
					variables: {
						scholarship: val
					}
				});

				let cont = 1;
				this.items = data.getScholarshipsRequestActualPeriod;
				
				// Le agrega la propiedad id con el valor del contador
				for (let i of this.items) {
					Object.defineProperty(i, "id", { value: cont++ });
				}
				this.loading = false;
			} catch (error) {}
		},
		// obtiene las solicitudes incompletas
		async getIncompleteRequests(val){
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query($scholarship: String!){
							getScholarshipsUnfinishedRequestActualPeriod(scholarship: $scholarship){
								name
								curp
								serial
								promedio
								type
								status
								allDocumentsApproved
							}
						}
					`,
					variables: {
						scholarship: val
					}
				});
				let cont = 1;
				this.items = data.getScholarshipsUnfinishedRequestActualPeriod;
				
				// Le agrega la propiedad id con el valor del contador
				for (let i of this.items) {
					Object.defineProperty(i, "id", { value: cont++ });
				}
				this.loading = false;
			} catch (error) { }
		},
		// Pone status Aceptado a la solicitud de beca
		async acceptScholarship(student) {
			try {
				await this.$apollo.mutate({
					mutation: gql`
						mutation(
							$curp: String!
							$status: String!
							$type: String!
						) {
							checkScholarshipRequest(
								curp: $curp
								status: $status
								type: $type
							)
						}
					`,
					variables: {
						curp: student.curp,
						status: "Aprobada",
						type: this.type
					}
				});
				// const index = this.items.indexOf(student);
				// this.items.splice(index, 1);
			} catch (error) {}
		},
		// Pone status Rechazado a la solicitud de beca
		async rejectScholarship(student) {
			try {
				await this.$apollo.mutate({
					mutation: gql`
						mutation(
							$curp: String!
							$status: String!
							$type: String!
						) {
							checkScholarshipRequest(
								curp: $curp
								status: $status
								type: $type
							)
						}
					`,
					variables: {
						curp: student.curp,
						status: "Rechazada",
						type: this.type
					}
				});
				// const index = this.items.indexOf(student);
				// this.items.splice(index, 1);
			} catch (error) {}
		},
		// subscription que regresa las solicitudes de becas
		getList() {
			const subs = this.$apollo.subscribe({
				query: gql`
					subscription {
						scholarshipRequests {
							name
							curp
							serial
							promedio
							status
							type
							allDocumentsApproved
						}
					}
				`
			});
			subs.subscribe({
				next: data => {
					let cont = 1;
					this.items = data.data.scholarshipRequests;

					// Le agrega la propiedad id con el valor del contador
					for (let i of this.items) {
						Object.defineProperty(i, "id", { value: cont++ });
					}
				}
			});
		},
		// cambia el nombre de la beca para la ruta
		route(scholarship) {
			switch (scholarship) {
				case "Talento especial":
					this.routeName = "talento-especial";
					break;
				case "Excelencia académica":
					this.routeName = "excelencia-académica";
					break;
				case "Mejora académica":
					this.routeName = "mejora-académica";
					break;
				case "Labsol":
					this.routeName = "labsol";
					break;
			}
		},
		// descarga los documentos del estudiante
		async downloadFiles(student){
			try {
				// console.log(student.curp);
				const response = await axios.get(
					`/getZip/${student.curp}`,
					{
						responseType: "arraybuffer",
						headers: {
							Authorization: sessionStorage.getItem("token")
						}
					}
				);
				const url = window.URL.createObjectURL(
					new Blob([response.data])
				);
				const link = document.createElement("a");
				link.href = url;
				link.setAttribute(
					"download",
					`${student.name.replace(/ /g, "")}${student.curp}.zip`
				);
				document.body.appendChild(link);
				link.click();
			}catch(err) { }
		},
	},
	mounted() {
		this.getList();
		EventBus.$on("changeSelectScholarship", data => {
			this.type = data.value;
			
			if(!data.toIncomplete){
				this.getRequests(data.value);
				this.route(data.value);
			}else{
				this.getIncompleteRequests(data.value);
			}
		});

		EventBus.$on("cleanUsersTable",() => {
			this.items = [];
		});
	}
}
</script>

<style scoped>
	.accept{
		background-color: green;
	}
	.reject{
		background-color: red;
	}
</style>